from flask import Flask, jsonify,request
from werkzeug.exceptions import default_exceptions
from werkzeug.exceptions import HTTPException
#import simplejson as json
import sys
from flask import request, Flask,  session, g, redirect, url_for, abort, render_template, flash
import os

#import all fort pie
import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt
import socket



app = Flask(__name__)

app.config['PROPAGATE_EXCEPTIONS'] = True

def state_hostgroup(hostgroup_name):
    socket_path = "/var/lib/nagios3/rw/live"
    s = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
    s.connect(socket_path)
    # Write command to socket
    s.send("""GET services
Filter: host_groups >= """+hostgroup_name.strip('\n')+"""
Stats: state = 0
Stats: state = 1
Stats: state = 2
Stats: state = 3
\n
""")
    s.shutdown(socket.SHUT_WR)
    answer = s.recv(100000000)
    table = [ line.split(';') for line in answer.split('\n')[:-1] ]
    return table

def camenbert(hostgoup_name,state,folderdest):
    plt.figure(1, figsize=(3,3))
    ax = plt.axes([0.1, 0.1, 0.8, 0.8])
    labels = 'Up', 'Warinig', 'Critical', 'Unreachable'
    fracs = state
    explode=(0, 0.05, 0, 0)
    colors=('g','y','r','b')
    plt.pie(fracs, colors=colors, shadow = True)
    plt.title(hostgoup_name, bbox={'facecolor':'0.8', 'pad':5})
    final_png = os.path.join("/static/plot",hostgoup_name+'.png')
    plt.savefig(os.path.join(folderdest,hostgoup_name+'.png'))
    return final_png

def tableau_service():
    socket_path = "/var/lib/nagios3/rw/live"
    s = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
    s.connect(socket_path)
    s.send("""GET services
Columns: host_name description state
Filter: state != 0
\n
""")
    s.shutdown(socket.SHUT_WR)
    answer = s.recv(100000000)
    table = [ line.split(';') for line in answer.split('\n')[:-1] ]
    return table


@app.route('/')
def overview():
    hotsgroups = ["passive-srvwinnrpe","passive-srvwin","passive-srvmail","passive-srvdns","all"]
    folderdest = "/opt/challans_nagios_overview/static/plot/"
    list_png = list()
    for hostgoup_name in hotsgroups:
        state = state_hostgroup(hostgoup_name)
        list_png.append((hostgoup_name,camenbert(hostgoup_name,state[0],folderdest)))
    info_generale = tableau_service()
    return render_template('overview.html',list_png=list_png,info_generale=info_generale)


#make_json_app(__name__)

if __name__ == "__main__":
  app.debug = True
  app.run(host='0.0.0.0',port=8081, debug=True)

